<?php

/*
# This file provides the options page for customizing TSE.
# Please do not edit this file.
*/

// Add options page: Settings -> Tango Smileys Extended
function tse_add_options_submenu() {
	$tse_options_page = add_submenu_page( 'options-general.php', 'Tango Smileys Extended: Options', 
		'Tango Smileys Extended', 'manage_options', 'tango-smileys-extended', 'tse_options' );
	add_action( "admin_print_scripts-$tse_options_page", 'tse_options_script' );
	add_action( "admin_print_styles-$tse_options_page", 'tse_options_style' );
}
add_action( 'admin_menu', 'tse_add_options_submenu' );

// Create options page START

function tse_options_init() {
	register_setting( 'tse_options', 'tango_smileys_extended' ); // Optional 3rd arg: Validation
}
add_action( 'admin_init', 'tse_options_init' );

function tse_options() {
	$tse = get_option( 'tango_smileys_extended' );
	global $tse_version;
?>
<div class="wrap">
	<div id="icon-options-general" class="icon32"><br /></div>
	<h2>Tango Smileys Extended: Options</h2>
	<form action="options.php" method="post" name="tse_options">
		<?php settings_fields( 'tse_options' ); ?>
		<input type="hidden" id="version" name="tango_smileys_extended[version]" value="<?php echo $tse_version; ?>" />
		<h3>General Options</h3>
		<table class="form-table">
			<tr valign="top">
				<th scope="row">Use default WordPress smilies?</th>
				<td>
					<input type="checkbox" id="wp_smilies" name="tango_smileys_extended[wp_smilies]" <?php ison( $tse['wp_smilies'] ); ?> onclick="checkit(this.id);" />
					<span class="red">This will disable Tango Smileys Extended!</span>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row">Enable <acronym title="Tango Smileys Extended">TSE</acronym> for:</th>
				<td>
					<input type="checkbox" id="tse_posts" name="tango_smileys_extended[posts]" <?php ison( $tse['posts'] ); ?> onclick="checkit(this.id);" />
					<span>Posts</span>
					<br />
					<input type="checkbox" id="tse_pages" name="tango_smileys_extended[pages]" <?php ison( $tse['pages'] ); ?> onclick="checkit(this.id);" />
					<span>Pages</span>
					<br />
					<input type="checkbox" id="tse_comments" name="tango_smileys_extended[comments]" <?php ison( $tse['comments'] ); ?> onclick="checkit(this.id);" />
					<span>Comments</span>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row">Smiley size:</th>
				<td>
					<input type="text" id="tse_smileysize" name="tango_smileys_extended[smileysize]" value="<?php echo $tse['smileysize']; ?>" size="1" maxlength="2" />
					<span>px</span>&nbsp;&nbsp;&nbsp;<span class="blue">[Number: 16 to 24]</span>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row">Enable <acronym title="Click to Insert">CTI</acronym> in:</th>
				<td>
					<input type="checkbox" id="tse_posts_cti" name="tango_smileys_extended[posts_cti]" <?php ison( $tse['posts_cti'] ); ?> onclick="checkit(this.id);" />
					<span>Posts</span>
					<br />
					<input type="checkbox" id="tse_pages_cti" name="tango_smileys_extended[pages_cti]" <?php ison( $tse['pages_cti'] ); ?> onclick="checkit(this.id);" />
					<span>Pages</span>
					<br />
					<input type="checkbox" id="tse_comments_cti" name="tango_smileys_extended[comments_cti]" <?php ison( $tse['comments_cti'] ); ?> onclick="checkit(this.id);" />
					<span>Comments</span>
					<br />
					<input type="checkbox" id="tse_comments_mce" name="tango_smileys_extended[comments_mce]" <?php ison( $tse['comments_mce'] ); ?> onclick="checkit(this.id);" />
					<span>MCEComments</span>
				</td>
			</tr>
		</table>
		<h3>CTI Options</h3>
		<table class="form-table">
			<tr valign="top">
				<th scope="row">Header Text:</th>
				<td>
					<input type="text" name="tango_smileys_extended[cti_header]" value="<?php echo $tse['cti_header']; ?>" size="30" maxlength="100" />
					<span>Placed above the CTI box</span>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row">Size:</th>
				<td>
					<span>Width:</span>
					<input type="text" name="tango_smileys_extended[cti_width]" value="<?php echo $tse['cti_width']; ?>" size="3" maxlength="5" />
					<span>px / %</span>&nbsp;&nbsp;&nbsp;<span class="blue">[Include % for percentage]</span>
					<br />
					<span>Height:</span>
					<input type="text" name="tango_smileys_extended[cti_height]" value="<?php echo $tse['cti_height']; ?>" size="3" maxlength="3" />
					<span>px</span>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row">Background:</th>
				<td>
					<input type="text" name="tango_smileys_extended[cti_bg]" value="<?php echo $tse['cti_bg']; ?>" size="30" maxlength="100" />
					<span>Any valid CSS value for BACKGROUND</span>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row">Border:</th>
				<td>
					<span>Width:</span>
					<input type="text" name="tango_smileys_extended[cti_borders]" value="<?php echo $tse['cti_borders']; ?>" size="1" maxlength="2" />
					<span>px</span>
					<br />
					<span>Style:</span>
					<input type="text" name="tango_smileys_extended[cti_bordert]" value="<?php echo $tse['cti_bordert']; ?>" size="10" maxlength="12" />
					<span>Any valid CSS value for BORDER-STYLE</span>&nbsp;&nbsp;&nbsp;<span class="blue">[Single values only]</span>
					<br />
					<span>Color:</span>
					<input type="text" name="tango_smileys_extended[cti_borderc]" value="<?php echo $tse['cti_borderc']; ?>" size="10" maxlength="20" />
					<span>Any valid CSS value for BORDER-COLOR</span>&nbsp;&nbsp;&nbsp;<span class="blue">[Single values only]</span>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row">Available Smileys:</th>
				<td>
					<input type="checkbox" name="tango_smileys_extended[standard]" <?php ison( $tse['standard'] ); ?> />
					<span>Standard</span>
					<?php tse_options_smiley_showcase( 'standard' ); ?>
					<br />
					<input type="checkbox" name="tango_smileys_extended[extended]" <?php ison( $tse['extended'] ); ?> />
					<span>Extended</span>
					<?php tse_options_smiley_showcase( 'extended' ); ?>
					<br />
					<input type="checkbox" name="tango_smileys_extended[gestures]" <?php ison( $tse['gestures'] ); ?> />
					<span>Gestures</span>
					<?php tse_options_smiley_showcase( 'gestures' ); ?>
					<br />
					<input type="checkbox" name="tango_smileys_extended[special]" <?php ison( $tse['special'] ); ?> />
					<span>Special</span>
					<?php tse_options_smiley_showcase( 'special' ); ?>
					<br />
					<input type="checkbox" name="tango_smileys_extended[animals]" <?php ison( $tse['animals'] ); ?> />
					<span>Animals</span>
					<?php tse_options_smiley_showcase( 'animals' ); ?>
					<br />
					<input type="checkbox" name="tango_smileys_extended[foodndrink]" <?php ison( $tse['foodndrink'] ); ?> />
					<span>Food and Drink</span>
					<?php tse_options_smiley_showcase( 'foodndrink' ); ?>
					<br />
					<input type="checkbox" name="tango_smileys_extended[other]" <?php ison( $tse['other'] ); ?> />
					<span>Other</span>
					<?php tse_options_smiley_showcase( 'other' ); ?>
				</td>
			</tr>
		</table>
		<p class="submit"><input type="submit" class="button-primary" value="Update Options &raquo;" /></p>
	</form>
	<div><?php echo get_option( 'plugin_error' ); ?></div>
</div>
<?php
}

function tse_options_style() {
echo <<<STYLE
	<style type="text/css">
		acronym {
			color: #008;
			cursor: help;
			border-bottom: 1px dotted #00f !important;
		}
		.red {
			color: #f00;
		}
		.blue {
			color: #00f;
		}
/*		.red, .blue, .label {
			vertical-align: text-top;
		}*/
		td span {
			vertical-align: text-top;
		}
		.showcase {
			width: 360px;
		}
	</style>
STYLE;
}

function tse_options_script() {
	echo '<script type="text/javascript" src="' . plugins_url( 'tse-options.js', __FILE__ ) . '"></script>';
}

function tse_options_smiley_showcase( $option ) {
	$smileys = tseCTI_get_smileys( $option );
	$output = '';
	for ( $i = 0; $i < sizeof( $smileys ); $i++ ) {
		$smiley = plugins_url( "/tango/{$smileys[$i][1]}", __FILE__ );
		$output .= "<img src='$smiley' alt='{$smileys[$i][2]}' title='{$smileys[$i][2]} ( {$smileys[$i][0]} )' />";
	}
	echo '<div class="showcase">' . $output . '</div>';
}

function ison( $option ) {
	if ( $option ) {
		echo 'checked="checked"';
	}
}

// Create options page END
?>